# $Revision: 1.102 $, $Date: 2012/02/07 00:09:56 $
# TODO
# - localization fix in files
# - 21:07:41  jtiai> set htdocs_location in trac ini to for example /trac-htdocs/
Summary:	Integrated SCM, Wiki, Issue tracker and project environment
Summary(pl.UTF-8):	Zintegrowane scm, wiki, system śledzenia problemów i środowisko projektowe
Name:		trac
Version:	0.12.3
Release:	1
License:	BSD-like
Group:		Applications/WWW
Source0:	http://ftp.edgewall.com/pub/trac/Trac-%{version}.tar.gz
# Source0-md5:	0cef201e223fafb5c3dd99577403f572
Source1:	%{name}-apache.conf
Source2:	%{name}-lighttpd.conf
Source3:	%{name}.ico
Source4:	%{name}.ini
Source5:	%{name}-enableplugin.py
Source6:	%{name}-upgrade.py
Patch0:		%{name}-root2http.patch
Patch1:		%{name}-defaults.patch
Patch2:		inherit-global-%{name}.ini.patch
Patch3:		silvercity-javascript-mimetypes.patch
URL:		http://trac.edgewall.org/
BuildRequires:	python >= 1:2.1
BuildRequires:	python-babel >= 0.9.5
BuildRequires:	python-devel >= 1:2.1
BuildRequires:	python-distribute
BuildRequires:	python-genshi
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 1.268
BuildRequires:	sed >= 4.0
#Requires:	apache(mod_env) || lighttpd-mod_fastcgi
Requires:	group(http)
Requires:	jquery
Requires:	python-clearsilver >= 0.9.3
Requires:	python-trac = %{version}-%{release}
Requires:	webapps
Requires:	webserver(access)
Requires:	webserver(alias)
Requires:	webserver(auth)
Requires:	webserver(cgi)
Requires:	webserver(mime)
Requires:	webserver(rewrite)
# TODO
# If apache is the webserver, apache-mod_python is required! What can do?
#Suggests:	apache-mod_python >= 3.1.3
#Suggests:	lighttpd-mod_fastcgi
#Suggests:	python-textile >= 2.0
Obsoletes:	trac-plugin-webadmin
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_appdir		%{_datadir}/%{name}
%define		_webapps	/etc/webapps
%define		_webapp		%{name}
%define		_sysconfdir	%{_webapps}/%{_webapp}

%description
Trac is a minimalistic web-based software project management and
bug/issue tracking system. It provides an interface to the Subversion
revision control systems, an integrated wiki, flexible issue tracking
and convenient report facilities.

%description -l pl.UTF-8
Trac to minimalistyczny, oparty na WWW zarządca projektów i system
śledzenia błędów/problemów. Dostarcza interfejs do systemu kontroli
wersji Subversion, zintegrowane wiki, elastyczne śledzenie problemów i
wygodne ułatwienia do raportowania.

%package -n python-trac
Summary:	Trac Python modules
Group:		Development/Languages/Python
Requires:	python >= 1:2.4
# python-distribute for pkg_resources module
Requires:	python-distribute
Requires:	python-genshi >= 0.6
Requires:	python-sqlite >= 2.5.5
Requires:	python-subversion >= 1.2.0
Suggests:	python-babel >= 0.9.5
Suggests:	python-docutils >= 0.6
Suggests:	python-pygments >= 0.6
Suggests:	python-pytz
Conflicts:	trac < 0.11.7-3

%description -n python-trac
Trac Python modules.

%prep
%setup -q -n Trac-%{version}
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1

# using system jquery package
rm trac/htdocs/js/jquery.js

%build
%{__python} setup.py build

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_sysconfdir},%{_sbindir},/var/lib/%{name},%{_datadir}/%{name}/{plugins,templates}}

%{__python} setup.py install \
	--skip-build \
	--optimize=2 \
	--root=$RPM_BUILD_ROOT

cp -a %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/apache.conf
cp -a %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/httpd.conf
cp -a %{SOURCE2} $RPM_BUILD_ROOT%{_sysconfdir}/lighttpd.conf

# utility script to enable extra plugins
install -p %{SOURCE5} $RPM_BUILD_ROOT%{_sbindir}/%{name}-enableplugin
# handle upgrades
install -p %{SOURCE6} $RPM_BUILD_ROOT%{_sbindir}/%{name}-upgrade

# keep paths from 0.10 install, we want fixed paths so we do not have to update
# webserver config each time with the upgrade.
install -d $RPM_BUILD_ROOT%{_appdir}/cgi-bin
mv $RPM_BUILD_ROOT{%{py_sitescriptdir}/trac,%{_appdir}}/htdocs

rm $RPM_BUILD_ROOT%{_appdir}/htdocs/README

install -p cgi-bin/trac.*  $RPM_BUILD_ROOT%{_appdir}/cgi-bin

cp -a %{SOURCE4} $RPM_BUILD_ROOT%{_sysconfdir}/trac.ini
cp -a %{SOURCE3} $RPM_BUILD_ROOT%{_appdir}/htdocs/%{name}.ico
> $RPM_BUILD_ROOT%{_sysconfdir}/htpasswd

# remove .py files, leave just compiled ones.
%py_postclean

# we don't need these runtime
rm -rf $RPM_BUILD_ROOT%{py_sitescriptdir}/trac/tests

# collect lang files
echo "%dir %{_appdir}/htdocs/js/messages" > %{name}.lang
for a in $RPM_BUILD_ROOT%{_appdir}/htdocs/js/messages/*.js; do
	f=${a##*/}
	l=${f%.js}
	echo "%lang($l) ${a#$RPM_BUILD_ROOT}"
done >> %{name}.lang

# TODO: move to /usr/share/locale as trac.mo catalog
echo "%dir %{py_sitescriptdir}/trac/locale" >> %{name}.lang
for a in $RPM_BUILD_ROOT%{py_sitescriptdir}/trac/locale/*/LC_MESSAGES/*.mo; do
	d=${a%%/LC_MESSAGES*}
	l=${d##*/}
	echo "%lang($l) ${d#$RPM_BUILD_ROOT}"
done >> %{name}.lang

%clean
rm -rf $RPM_BUILD_ROOT

%triggerin -- apache1 < 1.3.37-3, apache1-base
%webapp_register apache %{_webapp}

%triggerun -- apache1 < 1.3.37-3, apache1-base
%webapp_unregister apache %{_webapp}

%triggerin -- apache < 2.2.0, apache-base
%webapp_register httpd %{_webapp}

%triggerun -- apache < 2.2.0, apache-base
%webapp_unregister httpd %{_webapp}

%triggerin -- lighttpd
%webapp_register lighttpd %{_webapp}

%triggerun -- lighttpd
%webapp_unregister lighttpd %{_webapp}

%post
if [ "$1" = 1 ]; then
%banner %{name} -e <<EOF

To create new trac environment run as root:
# trac-admin /var/lib/trac/project initenv
and chown -R it to webserver user (http).

EOF
#'

# NOTE(s)
#- we made the parent directory (/var/lib/trac) g+s, but db/* files
#  needed to be really writable for web user, so better suggest
#  chown -R than chmod single file(s)?

fi

%files -f %{name}.lang
%defattr(644,root,root,755)
%doc AUTHORS ChangeLog INSTALL README THANKS UPGRADE
%doc contrib
%dir %attr(750,root,http) %{_sysconfdir}
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/apache.conf
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/httpd.conf
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/lighttpd.conf
%attr(640,root,http) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/htpasswd
%attr(640,root,http) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/trac.ini

%attr(755,root,root) %{_sbindir}/trac-enableplugin
%attr(755,root,root) %{_sbindir}/trac-upgrade
%attr(755,root,root) %{_bindir}/tracd

#%{_mandir}/man1/trac*.1*

%dir %{_appdir}
%dir %{_appdir}/cgi-bin
%attr(755,root,root) %{_appdir}/cgi-bin/trac.cgi
%attr(755,root,root) %{_appdir}/cgi-bin/trac.fcgi
%dir %{_appdir}/htdocs
%dir %{_appdir}/plugins
%dir %{_appdir}/templates
%{_appdir}/htdocs/*.gif
%{_appdir}/htdocs/*.ico
%{_appdir}/htdocs/*.png
%{_appdir}/htdocs/css
%{_appdir}/htdocs/guide

%dir %{_appdir}/htdocs/js
%{_appdir}/htdocs/js/*.js

# keep upgrade data in main pkg only
%{py_sitescriptdir}/trac/upgrades

# project data is stored there
%attr(2770,root,http) %dir /var/lib/trac

%files -n python-trac
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/trac-admin

%dir %{py_sitescriptdir}/%{name}
%{py_sitescriptdir}/trac/*.py[co]
%dir %{py_sitescriptdir}/trac/locale
%{py_sitescriptdir}/trac/admin
%{py_sitescriptdir}/trac/db
%{py_sitescriptdir}/trac/mimeview
%{py_sitescriptdir}/trac/prefs
%{py_sitescriptdir}/trac/search
%{py_sitescriptdir}/trac/templates
%{py_sitescriptdir}/trac/ticket
%{py_sitescriptdir}/trac/timeline
%{py_sitescriptdir}/trac/util
%{py_sitescriptdir}/trac/versioncontrol
%{py_sitescriptdir}/trac/web
%{py_sitescriptdir}/trac/wiki

%{py_sitescriptdir}/%{name}opt
%{py_sitescriptdir}/Trac-*.egg-info

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: trac.spec,v $
Revision 1.102  2012/02/07 00:09:56  caleb
- Up to 0.12.3

Revision 1.101  2012/01/26 23:03:37  glen
- add webserver alias for plugins' htdocs

Revision 1.100  2011/10/21 23:02:01  zbyniu
- test.* are needed for deleting wiki page; rel 3

Revision 1.99  2011/09/16 12:27:40  glen
- add more javascript mimetypes

Revision 1.98  2011/07/28 13:55:45  uzsolt
- auth and cgi required
- python mod?

Revision 1.97  2011/02/01 10:18:35  glen
- up to 0.12.2

Revision 1.96  2010/10/11 13:20:32  caleb
- Up to 0.12.1

Revision 1.95  2010/09/30 16:04:41  glen
- move trac-admin to python-trac package,
  so you could use in svn post-commit hook sth like:
  trac-admin /var/lib/trac/project changeset added subrepo "$REV"
- rel 9

Revision 1.94  2010/09/28 05:48:11  glen
- add trac-upgrade script, sets [inherit] section for now
- rel 8

Revision 1.93  2010/09/13 20:16:08  glen
- setup to inherit /etc/webapps/trac/trac.ini in new projects
  you still need to alter existing project youself

Revision 1.92  2010/09/13 17:15:46  glen
- files fix

Revision 1.91  2010/09/13 17:12:46  glen
- package plugins and templates dir in /usr/share/trac

Revision 1.90  2010/08/24 10:47:06  glen
- require python-distribute to catch pkg_resources module

Revision 1.89  2010/08/24 10:39:09  glen
- use real cgi/fcgi scripts, not templates to install; rel 4

Revision 1.88  2010/08/11 19:48:28  zbyniu
- rel 3

Revision 1.87  2010/07/12 15:04:48  glen
- no webserver deps to python package

Revision 1.86  2010/07/12 15:04:05  glen
- do not enforce your webserver preferrence

Revision 1.85  2010/07/09 11:25:21  arekm
- release 2

Revision 1.84  2010/06/21 08:25:36  paszczus
- added R: apache-mod_python and S: webserver(access) for python subpackage

Revision 1.83  2010/06/15 16:10:25  glen
- %lang flagging localization

Revision 1.82  2010/06/15 15:53:26  glen
- use --optimize=2 instead of compiling in spec

Revision 1.81  2010/06/15 15:52:10  glen
- compile also optimized .py
- verbose files in python package
- localization is compiled if python-genshi present

Revision 1.80  2010/06/15 15:38:18  glen
- BR python-babel, call compile_catalog manually

Revision 1.79  2010/06/15 14:40:24  caleb
- Current upstream project URL
- Corrected conflicts version

- Suggest python-pytz per upstream docs

Revision 1.78  2010/06/15 14:14:03  glen
- some webserver deps

Revision 1.77  2010/06/15 13:11:58  caleb
- Fixed versions and added missing requires per upstream docs

Revision 1.76  2010/06/15 12:22:06  caleb
- Be as lenient as possible with dependency versions. Error given by trac confirmed to be caused by bug fixed in pysqlite 2.5.5

Revision 1.75  2010/06/15 10:05:28  caleb
- Upstream project claims pysqlite 2.5.x compatability but in testing on PLD, trac database upgrades from 0.11.x to 0.12 fail on pysqlite < 2.6.0. See upstream bug report http://trac.edgewall.org/ticket/9434

Revision 1.74  2010/06/14 09:28:44  caleb
- Up to 0.12

Revision 1.73  2010/04/07 09:42:47  glen
- add trac-enableplugin script to be able to enable additional plugins automatically; rel 3

Revision 1.72  2010/04/06 15:41:41  glen
- use system jquery; rel 2

Revision 1.71  2010/03/21 18:48:04  zawadaa
- up to 0.11.7
- STBR

Revision 1.70  2009/12/13 03:02:16  charles
- up to 0.11.6

Revision 1.69  2009/07/18 12:24:19  arekm
- up to 0.11.5

Revision 1.68  2009/06/03 08:03:58  glen
- add bugfix for svn1.6; rel 3

Revision 1.67  2009/04/28 17:07:07  glen
- python-trac for trac python code only; rel 2

Revision 1.66  2009/04/03 11:20:05  arekm
- up to 0.11.4

Revision 1.65  2009/04/03 11:10:29  arekm
- trac can use various sqlite versions

Revision 1.64  2009/03/03 11:04:48  glen
- aaa

Revision 1.63  2009/03/03 11:00:36  glen
- complete trace

Revision 1.62  2009/03/03 10:59:44  glen
- no, sqlite1 still needed:
   Failed to create environment.
  global name 'sqlite' is not defined
  Traceback (most recent call last):
    File "/usr/share/python2.6/site-packages/trac/admin/console.py", line 605, in do_initenv
    File "/usr/share/python2.6/site-packages/trac/env.py", line 204, in __init__
    File "/usr/share/python2.6/site-packages/trac/env.py", line 327, in create
    File "/usr/share/python2.6/site-packages/trac/db/api.py", line 70, in init_db
    File "/usr/share/python2.6/site-packages/trac/db/sqlite_backend.py", line 136, in init_db
  NameError: global name 'sqlite' is not defined

Revision 1.61  2009/02/20 10:46:35  arekm
- rel 2; runs with sqlite(3) now

Revision 1.60  2009/02/16 22:31:32  glen
- update to 0.11.3

Revision 1.59  2009/02/16 22:25:07  glen
- merge Trac 0.11.2.1 from DEVEL

Revision 1.58  2008/10/30 16:35:53  arekm
- release 4

Revision 1.57  2008/10/08 15:36:03  glen
- release 3

Revision 1.56  2008/10/03 18:06:04  arekm
- release 2

Revision 1.55  2008/08/07 13:37:12  glen
- util patch outdated

Revision 1.54  2008/08/06 16:49:15  glen
- update to 0.10.5

Revision 1.53  2008/08/06 16:33:49  glen
- needs setuptools for modules handling
- doesn't use svn cli tools; rel 5

Revision 1.52  2008/08/06 15:04:54  glen
- lighttpd config needs fastcgi (how should this be handled with deps)

Revision 1.51  2008-05-30 13:54:52  glen
- also set umask 006

Revision 1.50  2008-05-29 15:54:28  glen
- trac-admin: switch to user http when ran as root; rel 3

Revision 1.49  2008-05-29 09:46:09  glen
- updated lighttpd config to support graceful restarts; rel 2

Revision 1.48  2008-05-26 12:33:37  glen
- "Modified BSD" is "BSD-like"? http://trac.edgewall.org/wiki/TracLicense

Revision 1.47  2008-01-07 14:26:34  glen
- R: webserver(access) (authz_host on apache2)

Revision 1.46  2007/05/01 16:30:17  rotom
- up to 0.10.4

Revision 1.45  2007/03/26 21:18:54  rotom
- up to 0.10.3.1

Revision 1.44  2007/02/12 22:09:18  glen
- tabs in preamble

Revision 1.43  2007/02/12 01:06:35  baggins
- converted to UTF-8

Revision 1.42  2007/01/17 17:02:44  jajcus
Version: 0.10.3

Revision 1.41  2006/11/17 01:39:15  andree
- upgrade to 0.10.2 (security fix)

Revision 1.40  2006/11/13 09:51:28  glen
- 0.10.1 (xss fix)

Revision 1.39  2006/10/09 08:34:38  patrys
- up to 0.10

Revision 1.38  2006/10/01 20:37:19  glen
- rel 2

Revision 1.37  2006/09/29 21:25:58  glen
- update webapp triggers due apache1 package split

Revision 1.36  2006/08/11 15:44:06  patrys
- up to 0.9.6

Revision 1.35  2006/07/20 18:18:45  glen
- lighttpd integration, not sure what to do with requires
- drop old trigger

Revision 1.34  2006/04/21 16:31:20  deejay1
- up to 0.9.5

Revision 1.33  2006/02/22 14:22:12  deejay1
- up to 0.9.4 (bugfix release); rel. 1

Revision 1.32  2006/02/03 18:26:19  glen
- fix regex for apache1, rel 3

Revision 1.31  2006/02/03 16:50:03  baggins
- release 2

Revision 1.30  2006/02/02 15:14:49  glen
- update apache2 trigger to match apache-base in case somebody decides not to
  use apache2.2 virtual pkg (freedom of choice one of the pld mottos)

Revision 1.29  2006/02/01 21:04:13  glen
- rpm-pythonprov should be BR

Revision 1.28  2006/02/01 15:02:29  glen
- BR: rpm-pythonprov

Revision 1.27  2006/02/01 14:56:59  glen
- started reviewing mod_python patches
- use %service even in triggers

Revision 1.26  2006/01/26 14:33:24  glen
- add cve ref

Revision 1.25  2006/01/20 21:50:47  arekm
- up to 0.9.3, resolves CVE-2005-4305

Revision 1.24  2005/12/07 02:02:53  glen
- typhon epoch

Revision 1.23  2005/12/06 13:05:47  glen
- convert to webapps framework; rel 1

Revision 1.22  2005/12/06 03:06:41  aredridel
- up to 0.9.2, fixes security flaw
- STBR

Revision 1.21  2005/11/03 09:28:14  arekm
- up to 0.9

Revision 1.20  2005/10/07 13:07:15  czarny
- BR: python-devel

Revision 1.19  2005/08/15 19:07:59  glen
- use apache config triggers
- add contrib/ to %doc
- %{py_postclean} enabled to remove .py from DESTDIR
- rel 3

Revision 1.18  2005/07/24 03:12:24  aredridel
- actually works
- STBR

Revision 1.17  2005/06/21 22:43:11  patrys
- up to 0.8.4, security fix release

Revision 1.16  2005/06/20 08:46:48  radzio
- R:python-sqlite1
- rel 2
- STBR

Revision 1.15  2005/06/03 19:25:02  aredridel
- up to 0.8.2

Revision 1.14  2005/05/30 08:14:38  radzio
- rel 1, STBR

Revision 1.13  2005/05/29 22:07:16  radzio
- fix Patch0 (compatibility with Subversion 1.2)
- add Patch1 (fix path in trac/siteconfig.py to be more Linux friendly)
- rel 0.3 (tests needed)

Revision 1.12  2005/05/27 07:00:21  glen
- py_postclean macro is broken

Revision 1.11  2005/05/27 06:55:50  glen
- add py_ocomp and py_postclean back

Revision 1.10  2005/05/27 06:53:59  glen
- py_hardlink done by rpm

Revision 1.9  2005/05/26 21:21:56  aredridel
- patch for svn 1.2.0
- R: python-subversion >= 1.2.0
- rel 0.2

Revision 1.8  2005/03/06 11:17:17  glen
- R: group(http) as we have files listed with that gid

Revision 1.7  2005/03/06 10:36:18  glen
- fix %banner
- revert bundled trac-env creation

Revision 1.6  2005/02/15 15:59:02  glen
- add missing icon
- revert macros rev bump
- with data is off by default

Revision 1.5  2005/02/15 15:40:11  glen
- fix apache2 config linkage
- testing bundled trac-env
- add BR for py_ macros

Revision 1.4  2005/02/14 21:43:17  qboosh
- removed COPYING from doc (just GPL)

Revision 1.3  2005/02/14 21:36:52  qboosh
- pl

Revision 1.2  2005/02/14 21:01:34  glen
- progress... works now for me

Revision 1.1  2005/02/14 00:04:07  glen
- new
